-- Import ElvUI Engine
local E, L, DF = unpack(ElvUI); --Engine
local EE = ElvUI_EmbedRight

EE.initialized = false

EE:RegisterEvent("ADDON_LOADED")
EE:RegisterEvent("VARIABLES_LOADED")
EE:RegisterEvent("PLAYER_LOGIN")
EE:RegisterEvent("PLAYER_ENTERING_WORLD")
EE:RegisterEvent("PLAYER_LOGOUT")
EE:RegisterEvent("PLAYER_REGEN_DISABLED")
EE:RegisterEvent("PLAYER_REGEN_ENABLED")

local function UpdateLocale()
	local gameLocale = GetLocale()
	
	-- enGB and enUS are the same
	if gameLocale == "enGB" then
		gameLocale = "enUS"
	end
	
	-- esMX and esES are the same
	if gameLocale == "esMX" then
		gameLocale = "esES"
	end
	
	if gameLocale == "enUS" then
		-- L["Toggle"] = "Toggle"
		-- L["Embed"] = 'Embed'
		-- L["Embed Right"] = 'Embed Right'			
		-- L["Toggle Embedded with right chat"] = 'Toggle Embedded with right chat'
		-- L["Toggle Embedded when OOC"] = 'Toggle Embedded when OOC'
		-- L["When the right chat gets shown the embedded addon will hide, when the right chat gets hidden the embedded addon will show."] = 'When the right chat gets shown the embedded addon will hide, when the right chat gets hidden the embedded addon will show.'
		-- L["Hide the embedded addon when Out Of Combat. Only works when \"Toggle Embedded with right chat\" is NOT active."] = 'Hide the embedded addon when Out Of Combat. Only works when "Toggle Embedded with right chat" is NOT active.'
		-- L["EMBED_DESC"] = 'Choose an AddOn to embed to the right chat window, tooltip should never cover the addon up, and if you have a hook bar option for your addon the bar should stay above the addon if the chatwindow is hidden'

		L["TOGGLE"] = "Toggle"
		L["EMBED"] = 'Embed'
		L["EMBED_DESC"] = 'Choose an AddOn to embed to the right chat window, tooltip should never cover the addon up, and if you have a hook bar option for your addon the bar should stay above the addon if the chatwindow is hidden'
		L["EMBED_RIGHT"] = 'Embed Right'			
		L["TOGGLE_WITH_RIGHTCHAT"] = 'Toggle with right chat'
		L["TOGGLE_WITH_RIGHTCHAT_DESC"] = 'When the right chat gets shown the embedded addon will hide, when the right chat gets hidden the embedded addon will show.'
		L["TOGGLE_WHEN_OOC"] = 'Toggle when OOC'
		L["TOGGLE_WHEN_OOC_DESC"] = 'Hide the embedded addon when Out Of Combat. Only works when "Toggle Embedded with right chat" is NOT active.'
		
		L["OMEN"] = 'Omen'
		L["RECOUNT"] = 'Recount'
		L["SKADA"] = 'Skada'
		
	elseif gameLocale == "zhCN" then
	elseif gameLocale == "frFR" then
	elseif gameLocale == "deDE" then
	elseif gameLocale == "krUS" then
	elseif gameLocale == "ruRU" then
	elseif gameLocale == "esES" then
	elseif gameLocale == "zhTW" then
	
	end
end

local function UpdateSkinsOptions()

	-- E.Options.args.skins.get = function(info) return E.db.skins[ info[#info] ] end,
	-- E.Options.args.skins.set = function(info, value) E.db.skins[ info[#info] ] = value end,

	E.Options.args.skins.args.embedright = {
		order = 2,
		type = "select",
		-- name = L["Embed Right"],
		name = L["EMBED_RIGHT"],
		desc = L["EMBED_DESC"],
		get = function(info) 
			return E.db.skins.embedright or "NONE"
		end,
		set = function(info, value) 
			E.db.skins.embedright = value
			if E.db.skins.embedrighttoggle == nil then
				E.db.skins.embedrighttoggle = true
			end
			StaticPopup_Show("CONFIG_RL")
		end,
		values = {
			["NONE"] = L["None"],
			["RECOUNT"] = L["RECOUNT"],
			["OMEN"] = L["OMEN"],
			["SKADA"] = L["SKADA"],
		},						
	}
	
	E.Options.args.skins.args.embedrighttoggle = {
		order = 5,
		type = "toggle",
		-- name = L["Toggle Embedded with right chat"],
		name = L["TOGGLE_WITH_RIGHTCHAT"],
		-- desc = L["When the right chat gets shown the embedded addon will hide, when the right chat gets hidden the embedded addon will show."],
		desc = L["TOGGLE_WITH_RIGHTCHAT_DESC"],
		get = function(info)
			return E.db.skins.embedrighttoggle
		end,
		set = function(info, value)
			E.db.skins.embedrighttoggle = value
			if value == false then
				if E.db.skins.embedrighttoggleocc == nil then
					E.db.skins.embedrighttoggleocc = true
				end
			end
			StaticPopup_Show("CONFIG_RL")
		end,
		disabled = function() return E.db.skins.embedright == "NONE" end,
	}

	E.Options.args.skins.args.embedrighttoggleooc = {
		order = 6,
		type = "toggle",
		-- name = L["Toggle Embedded when OOC"],
		name = L["TOGGLE_WHEN_OOC"],
		-- desc = L["Hide the embedded addon when Out Of Combat. Only works when \"Toggle Embedded with right chat\" is NOT active."],
		desc = L["TOGGLE_WHEN_OOC_DESC"],
		get = function(info)
			return E.db.skins.embedrighttoggleooc
		end,
		set = function(info, value)
			E.db.skins.embedrighttoggleooc = value
			StaticPopup_Show("CONFIG_RL")
		end,
		disabled = function() return E.db.skins.embedrighttoggle == true end,
	}
	
end

EE:SetScript("OnEvent",function(self, event, addon)

	if event == "ADDON_LOADED" and addon == "ElvUI_EmbedRight" then
		DEFAULT_CHAT_FRAME:AddMessage("ElvUI_EmbedRight loaded.")
		if E.initialized == true then 
			-- DEFAULT_CHAT_FRAME:AddMessage("ElvUI Initialized.")
			UpdateLocale()
			UpdateSkinsOptions()
			-- EE.RecountSetup()
			-- EE.OmenSetup()
			-- EE.SkadaSetup()
			EE.initialized = true
		end
		self:UnregisterEvent("ADDON_LOADED")
	end
	
	if event == "ADDON_LOADED" and addon == "ElvUI" then
	end
	
	if event == "VARIABLES_LOADED" then
		-- DEFAULT_CHAT_FRAME:AddMessage("ElvUI_EmbedRight variables loaded.")
		self:UnregisterEvent("VARIABLES_LOADED")
	end
	
	if event == "PLAYER_REGEN_DISABLED" then
		if E.db.skins.embedright == "NONE" then return end
		if E.db.skins.embedrighttoggle == true then
			-- DEFAULT_CHAT_FRAME:AddMessage("Entering combat!")
			RightChatPanel:Hide()
		end
		
		if E.db.skins.embedrighttoggleooc == true and E.db.skins.embedrighttoggle == false then
			if E.db.skins.embedright == "OMEN" then
			elseif E.db.skins.embedright == "RECOUNT" then
			elseif E.db.skins.embedright == "SKADA" then
				if Skada.db.profile.hidesolo then return end
				if Skada.db.profile.hideincomabt then return end
				for _, window in ipairs(Skada:GetWindows()) do
					window:Show()
					--[[
					if not window:IsShown() then
						window.db.hidden = false
						window:Show()
					end
					--]]
				end
			end
		end
	end

	if event == "PLAYER_REGEN_ENABLED" then
		if E.db.skins.embedright == "NONE" then return end
		if E.db.skins.embedrighttoggle == true then
			-- DEFAULT_CHAT_FRAME:AddMessage("Leaving combat!")
			RightChatPanel:Show()
		end
		if E.db.skins.embedrighttoggleooc == true and E.db.skins.embedrighttoggle == false then
			if E.db.skins.embedright == "OMEN" then
			elseif E.db.skins.embedright == "RECOUNT" then
			elseif E.db.skins.embedright == "SKADA" then
				for _, window in ipairs(Skada:GetWindows()) do
					window:Hide()
					--[[
					if window:IsShown() then
						window.db.hidden = true
						window:Hide()
					end
					--]]
				end
			end
		end
	end
	
	if event == "PLAYER_LOGIN" then
		-- self:UnregisterEvent("PLAYER_LOGIN")
		if (E.initialized == true) and (EE.initialized == false) then 
			-- DEFAULT_CHAT_FRAME:AddMessage("ElvUI Initialized.")
			UpdateLocale()
			UpdateSkinsOptions()
			-- EE.RecountSetup()
			-- EE.OmenSetup()
			-- EE.SkadaSetup()
			self:UnregisterEvent("PLAYER_LOGIN")
			EE.initialized = true
		end

		if EE.initialized == true then
			if E.db.skins.embedright == "RECOUNT" then
				EE.RecountSetup()
			elseif E.db.skins.embedright == "OMEN" then
				EE.OmenSetup()
			elseif E.db.skins.embedright == "SKADA" then
				EE.SkadaSetup()
			end
		end
	end
	
	if event == "PLAYER_ENTERING_WORLD" then
		if not EE.initialized then return end
		if E.db.skins.embedright == "NONE" then return end
		if not ElvUI_DTbar then return end
		-- DEFAULT_CHAT_FRAME:AddMessage("Disabling RightChat Datatext Panel")
		
		--[[
		local command = "RightChatTab_Datatext_Panel"
		-- local command = "RightChatTab_Datatext_Panel2"
		for k,v in ipairs(ElvUI_DTbar._table) do
			if (v:GetName():lower():match(command:lower())) then
				v:Hide()
				db[v:GetName()] = false
			end 
		end
		--]]
		
		RightChatTab_Datatext_Panel2:ClearAllPoints()
		local parent
		if E.db.skins.embedright == "RECOUNT" then
			parent = RecountToggleSwitch
		elseif E.db.skins.embedright == "OMEN" then
			parent = OmenToggleSwitch
		elseif E.db.skins.embedright == "SKADA" then
			parent = SkadaToggleSwitch
		end
		
		RightChatTab_Datatext_Panel2:Point("RIGHT", parent, "LEFT") -- if you use the skada embed code you might need to adjust the x-offset to allow room for the arrow button
		
		--[[
		if RightChatTab_Datatext_Panel then
			RightChatTab_Datatext_Panel.db['value'] = false
			RightChatTab_Datatext_Panel:Hide()
		end
		--]]

		--[[
		if RightChatTab_Datatext_Panel2 then
			RightChatTab_Datatext_Panel2.db['value'] = false
			RightChatTab_Datatext_Panel2:Hide()
		end
		--]]
		-- self:UnregisterEvent("PLAYER_ENTERING_WORLD")
	end
	
	if event == "PLAYER_LOGOUT" then
		-- DEFAULT_CHAT_FRAME:AddMessage("ElvUI_EmbedRight player logging out.")
		self:UnregisterEvent("PLAYER_LOGOUT")
	end

end)
