-- Import ElvUI Engine
local E, L, DF = unpack(ElvUI); --Engine
local EE = ElvUI_EmbedRight
local S = E:GetModule('Skins')

local function LoadSkin()
	if E.db.skins.omen.enable ~= true then return end
	-- Add proper check for addon
	if not Omen then return end
	
	if E.db.skins.embedright == "OMEN" then
		OmenBarList:Hide()
		local Omen_Skin = CreateFrame("Frame")
		Omen_Skin:RegisterEvent("PLAYER_ENTERING_WORLD")
		Omen_Skin:SetScript("OnEvent", function(self)
			self:UnregisterAllEvents()
			self = nil

			if not Omen.UpdateTitleBar_ then
				Omen.UpdateTitleBar_ = Omen.UpdateTitleBar
			end
			Omen.UpdateTitleBar = function() end
			OmenTitle:Kill()
			OmenBarList:ClearAllPoints()
			OmenBarList:SetPoint("TOPLEFT", OmenPanel, "TOPLEFT", 0, 0)
			OmenBarList:SetPoint("BOTTOMRIGHT", OmenPanel, "BOTTOMRIGHT", 0, 0)
			-- WIDTH?
			-- Recount.db.profile.MainWindowWidth = (E.db.core.panelWidth - 5)	
			Omen.db.profile.FrameStrata = "3-MEDIUM"			
			Omen.db.profile.Locked = true
			-- FONT?
			-- Recount.db.profile.Font = "ElvUI Font"
		end)
		
	end
	
	Omen:UpdateGrips()
	
	-- Force updates
	Omen:UpdateBarTextureSettings()
	Omen:UpdateBarLabelSettings()
	Omen:UpdateTitleBar()
	Omen:UpdateBackdrop()
	Omen:ReAnchorBars()
	Omen:ResizeBars()
	
	if RightChatTab then
		local button = CreateFrame('Button', 'OmenToggleSwitch', RightChatTab)
		button:Width(40)
		-- button:Height(RightChatPanel:GetHeight() - 4)
		button:Height(22)
		button:Point("RIGHT", RightChatTab, "RIGHT", -2, 0)
		
		button.tex = button:CreateTexture(nil, 'OVERLAY')
		button.tex:SetTexture([[Interface\AddOns\ElvUI\media\textures\vehicleexit.tga]])
		button.tex:Point('TOPRIGHT', -2, -2)
		button.tex:Height(button:GetHeight() - 4)
		button.tex:Width(16)
		
		button.text = button:CreateFontString(nil, "THINOUTLINE")
		button.text:FontTemplate()
		button.text:SetPoint('RIGHT', button.tex, 'LEFT')
		button.text:SetTextColor(unpack(E["media"].rgbvaluecolor))
		
		button:SetScript('OnEnter', function(self) button.text:SetText(L["TOGGLE"]..' '..L["OMEN"]) end)			
		button:SetScript('OnLeave', function(self) self.tex:Point('TOPRIGHT', -2, -2); button.text:SetText(nil) end)
		button:SetScript('OnMouseDown', function(self) self.tex:Point('TOPRIGHT', -4, -4) end)
		button:SetScript('OnMouseUp', function(self) self.tex:Point('TOPRIGHT', -2, -2) end)
		button:SetScript('OnClick', function(self) Omen:Toggle() end)
	end	
	
	if E.db.skins.embedrighttoggle == true then
		RightChatPanel:HookScript("OnShow", function()
			OmenBarList:Hide()
		end)
		RightChatPanel:HookScript("OnHide", function()
			OmenBarList:Show()
		end)
	end	

end

local function CreateEmbedOmen()
	local omenpanel = CreateFrame('Frame', 'OmenPanel', E.UIParent)
	omenpanel:Width(E.db.core.panelWidth)
	local panelHeight = E.db.core.panelHeight
	local tabHeight = 0
	if RightChatTab then
		tabHeight = RightChatTab:GetHeight() + 8
	end
	panelHeight = panelHeight - tabHeight
	omenpanel:Height(panelHeight)

	if RightChatTab then
		omenpanel:Point("TOPLEFT", RightChatTab,"BOTTOMLEFT", 0, -5)
	else
		omenpanel:Point("TOPLEFT", RightChatPanel,"TOPLEFT", 0, -5)
	end
	omenpanel:Point("BOTTOMRIGHT", RightChatPanel,"BOTTOMRIGHT", -5, 31)
	omenpanel:SetFrameLevel(5)
end

local function UpdateLocale()
	local gameLocale = GetLocale()
	
	-- enGB and enUS are the same
	if gameLocale == "enGB" then
		gameLocale = "enUS"
	end
	
	-- esMX and esES are the same
	if gameLocale == "esMX" then
		gameLocale = "esES"
	end
	
	if gameLocale == "enUS" then
	
	elseif gameLocale == "zhCN" then
	elseif gameLocale == "frFR" then
	elseif gameLocale == "deDE" then
	elseif gameLocale == "krUS" then
	elseif gameLocale == "ruRU" then
	elseif gameLocale == "esES" then
	elseif gameLocale == "zhTW" then
	
	end
end

function EE:OmenSetup()
	if not EE.initialized then return end
	
	UpdateLocale()
		
	if E.db.skins.embedright == "OMEN" then
		-- DEFAULT_CHAT_FRAME:AddMessage("[Omen] Embed enabled.")
		CreateEmbedOmen()
		LoadSkin()
	end
end