-- Import ElvUI Engine
local E, L, DF = unpack(ElvUI); --Engine
local EE = ElvUI_EmbedRight
local S = E:GetModule('Skins')

local function SkinFrame(frame)
	frame.bgMain = CreateFrame("Frame", nil, frame)
	--frame.bgMain:SetTemplate("Transparent")
	frame.bgMain:SetPoint("BOTTOMLEFT", frame, "BOTTOMLEFT")
	frame.bgMain:SetPoint("BOTTOMRIGHT", frame, "BOTTOMRIGHT")
	frame.bgMain:SetPoint("TOP", frame, "TOP", 0, -30)
	frame.bgMain:SetFrameLevel(frame:GetFrameLevel())
	
	frame.bgTitle = CreateFrame('Frame', nil, frame)
	frame.bgTitle:SetTemplate('Default', true)
	frame.bgTitle:Point("TOPRIGHT", frame, "TOPRIGHT", 0, -10)
	frame.bgTitle:Point("TOPLEFT", frame, "TOPLEFT", 0, -6)
	frame.bgTitle:Point("BOTTOM", frame, "TOP", 0, -28)
	--frame.bgTitle.backdropTexture:SetVertexColor(unpack(E['media'].bordercolor))
	frame.bgTitle:SetFrameLevel(frame:GetFrameLevel())
	
	frame.CloseButton:SetPoint("TOPRIGHT",frame,"TOPRIGHT",-1,-7)
	frame.CloseButton:SetNormalTexture("")
	frame.CloseButton:SetPushedTexture("")
	frame.CloseButton:SetHighlightTexture("")
	frame.CloseButton.t = frame.CloseButton:CreateFontString(nil, "OVERLAY")
	frame.CloseButton.t:FontTemplate()
	frame.CloseButton.t:SetPoint("CENTER", 0, 1)
	frame.CloseButton.t:SetText("X")
	
	S:HandleScrollBar(Recount_MainWindow_ScrollBarScrollBar)
	
	frame.Title:SetPoint("TOPLEFT",frame,"TOPLEFT",6,-11)
	frame.Title:FontTemplate(E["media"].dtFont, 10 ,  nil)
	frame.Title:SetTextColor(unpack(E["media"].rgbvaluecolor))
	frame:SetBackdrop(nil)
end

local function SkinFrame2(frame)
	frame.bgMain = CreateFrame("Frame", nil, frame)
	frame.bgMain:SetTemplate("Default")
	frame.bgMain:SetPoint("BOTTOMLEFT", frame, "BOTTOMLEFT")
	frame.bgMain:SetPoint("BOTTOMRIGHT", frame, "BOTTOMRIGHT")
	frame.bgMain:SetPoint("TOP", frame, "TOP", 0, -30)
	frame.bgMain:SetFrameLevel(frame:GetFrameLevel())
	
	frame.bgTitle = CreateFrame('Frame', nil, frame)
	frame.bgTitle:SetTemplate('Default', true)
	frame.bgTitle:Point("TOPRIGHT", frame, "TOPRIGHT", 0, -10)
	frame.bgTitle:Point("TOPLEFT", frame, "TOPLEFT", 0, -6)
	frame.bgTitle:Point("BOTTOM", frame, "TOP", 0, -28)
	frame.bgTitle:SetFrameLevel(frame:GetFrameLevel())
	
	frame.CloseButton:SetPoint("TOPRIGHT",frame,"TOPRIGHT",-1,-7)
	frame.CloseButton:SetNormalTexture("")
	frame.CloseButton:SetPushedTexture("")
	frame.CloseButton:SetHighlightTexture("")
	frame.CloseButton.t = frame.CloseButton:CreateFontString(nil, "OVERLAY")
	frame.CloseButton.t:FontTemplate()
	frame.CloseButton.t:SetPoint("CENTER", 0, 1)
	frame.CloseButton.t:SetText("X")
	
	S:HandleScrollBar(Recount_MainWindow_ScrollBarScrollBar)
	
	frame.Title:SetPoint("TOPLEFT",frame,"TOPLEFT",6,-11)
	frame.Title:FontTemplate(E["media"].dtFont, 10 ,  nil)
	frame.Title:SetTextColor(unpack(E["media"].rgbvaluecolor))
	frame:SetBackdrop(nil)
end

local function LoadSkin()
	if E.db.skins.recount.enable ~= true then return end
	-- Add proper check for addon
	if not Recount then return end

	-- Override bar textures
	Recount.UpdateBarTextures = function(self)
		for k, v in pairs(Recount.MainWindow.Rows) do
			v.StatusBar:SetStatusBarTexture(E["media"].normTex)
			v.StatusBar:GetStatusBarTexture():SetHorizTile(false)
			v.StatusBar:GetStatusBarTexture():SetVertTile(false)
		end
		--Recount:SetFont("ElvUI Font")
	end
	Recount.SetBarTextures = Recount.UpdateBarTextures

	-- Fix bar textures as they're created
	if not Recount.SetupBar_ then
		Recount.SetupBar_ = Recount.SetupBar
	end
	Recount.SetupBar = function(self, bar)
		self:SetupBar_(bar)
		bar.StatusBar:SetStatusBarTexture(E["media"].normTex)
	end

	-- Skin frames when they're created
	if not Recount.CreateFrame_ then
		Recount.CreateFrame_ = Recount.CreateFrame
	end
	Recount.CreateFrame = function(self, Name, Title, Height, Width, ShowFunc, HideFunc)
		local frame = self:CreateFrame_(Name, Title, Height, Width, ShowFunc, HideFunc)
		SkinFrame2(frame)
		return frame
	end

	if Recount.MainWindow then SkinFrame(Recount.MainWindow) end
	if Recount.ConfigWindow then SkinFrame2(Recount.ConfigWindow) end
	if Recount.GraphWindow then SkinFrame2(Recount.GraphWindow) end
	if Recount.DetailWindow then SkinFrame2(Recount.DetailWindow) end
	if Recount.ResetFrame then SkinFrame2(Recount.ResetFrame) end
	if _G["Recount_Realtime_!RAID_DAMAGE"] then SkinFrame2(_G["Recount_Realtime_!RAID_DAMAGE"].Window) end
	if _G["Recount_Realtime_!RAID_HEALING"] then SkinFrame2(_G["Recount_Realtime_!RAID_HEALING"].Window) end
	if _G["Recount_Realtime_!RAID_HEALINGTAKEN"] then SkinFrame2(_G["Recount_Realtime_!RAID_HEALINGTAKEN"].Window) end
	if _G["Recount_Realtime_!RAID_DAMAGETAKEN"] then SkinFrame2(_G["Recount_Realtime_!RAID_DAMAGETAKEN"].Window) end
	if _G["Recount_Realtime_Bandwidth Available_AVAILABLE_BANDWIDTH"] then SkinFrame2(_G["Recount_Realtime_Bandwidth Available_AVAILABLE_BANDWIDTH"].Window) end
	if _G["Recount_Realtime_FPS_FPS"] then SkinFrame2(_G["Recount_Realtime_FPS_FPS"].Window) end
	if _G["Recount_Realtime_Latency_LAG"] then SkinFrame2(_G["Recount_Realtime_Latency_LAG"].Window) end
	if _G["Recount_Realtime_Downstream Traffic_DOWN_TRAFFIC"] then SkinFrame2(_G["Recount_Realtime_Downstream Traffic_DOWN_TRAFFIC"].Window) end
	if _G["Recount_Realtime_Upstream Traffic_UP_TRAFFIC"] then SkinFrame2(_G["Recount_Realtime_Upstream Traffic_UP_TRAFFIC"].Window) end
	
	-- skin dropdown
	Recount.MainWindow.FileButton:HookScript("OnClick", function(self) if LibDropdownFrame0 then LibDropdownFrame0:SetTemplate() end end)

	if E.db.skins.embedright == "RECOUNT" then
		local Recount_Skin = CreateFrame("Frame")
		Recount_Skin:RegisterEvent("PLAYER_ENTERING_WORLD")
		Recount_Skin:SetScript("OnEvent", function(self)
			self:UnregisterAllEvents()
			self = nil

			Recount_MainWindow:ClearAllPoints()
			Recount_MainWindow:SetPoint("TOPLEFT", RecountPanel,"TOPLEFT", 0, 6)
			Recount_MainWindow:SetPoint("BOTTOMRIGHT", RecountPanel,"BOTTOMRIGHT", 0, 0)
			Recount.db.profile.MainWindowWidth = (E.db.core.panelWidth - 5)	
			Recount.db.profile.Locked = true
			Recount.db.profile.Font = "ElvUI Font"
		end)
		
	end
	
	Recount:LockWindows(Recount.db.profile.Locked)
	Recount:RefreshMainWindow()		
	
	if RightChatTab then
		local button = CreateFrame('Button', 'RecountToggleSwitch', RightChatTab)
		button:Width(55)
		-- button:Height(RightChatPanel:GetHeight() - 4)
		button:Height(22)
		button:Point("RIGHT", RightChatTab, "RIGHT", -2, 0)
		
		button.tex = button:CreateTexture(nil, 'OVERLAY')
		button.tex:SetTexture([[Interface\AddOns\ElvUI\media\textures\vehicleexit.tga]])
		button.tex:Point('TOPRIGHT', -2, -2)
		button.tex:Height(button:GetHeight() - 4)
		button.tex:Width(16)
		
		button.text = button:CreateFontString(nil, "THINOUTLINE")
		button.text:FontTemplate()
		button.text:SetPoint('RIGHT', button.tex, 'LEFT')
		button.text:SetTextColor(unpack(E["media"].rgbvaluecolor))
		
		button:SetScript('OnEnter', function(self) button.text:SetText(L["TOGGLE"]..' '..L["RECOUNT"]) end)			
		button:SetScript('OnLeave', function(self) self.tex:Point('TOPRIGHT', -2, -2); button.text:SetText(nil) end)
		button:SetScript('OnMouseDown', function(self) self.tex:Point('TOPRIGHT', -4, -4) end)
		button:SetScript('OnMouseUp', function(self) self.tex:Point('TOPRIGHT', -2, -2) end)
		button:SetScript('OnClick', function(self) if Recount.MainWindow:IsShown() then Recount.MainWindow:Hide() else Recount.MainWindow:Show();Recount:RefreshMainWindow() end end)
	end		
	
	if E.db.skins.embedrighttoggle == true then
		RightChatPanel:HookScript("OnShow", function()
			Recount_MainWindow:Hide()
		end)
		RightChatPanel:HookScript("OnHide", function()
			Recount_MainWindow:Show()
		end)
	end	
end

local function CreateEmbedRecount()
	local recountpanel = CreateFrame('Frame', 'RecountPanel', E.UIParent)
	recountpanel:Width(E.db.core.panelWidth)
	local panelHeight = E.db.core.panelHeight
	local tabHeight = 0
	if RightChatTab then tabHeight = RightChatTab:GetHeight() + 8; end
	panelHeight = panelHeight - tabHeight
	recountpanel:Height(panelHeight)
	if RightChatTab then recountpanel:Point("TOPLEFT", RightChatTab,"BOTTOMLEFT", 0, -5);
	else recountpanel:Point("TOPLEFT", RightChatPanel,"TOPLEFT", 0, -5); end
	recountpanel:Point("BOTTOMRIGHT", RightChatPanel,"BOTTOMRIGHT", -5, 31)
	recountpanel:SetFrameLevel(5)
end

local function UpdateLocale()
	local gameLocale = GetLocale()
	
	-- enGB and enUS are the same
	if gameLocale == "enGB" then
		gameLocale = "enUS"
	end
	
	-- esMX and esES are the same
	if gameLocale == "esMX" then
		gameLocale = "esES"
	end
	
	if gameLocale == "enUS" then
	
	elseif gameLocale == "zhCN" then
	elseif gameLocale == "frFR" then
	elseif gameLocale == "deDE" then
	elseif gameLocale == "krUS" then
	elseif gameLocale == "ruRU" then
	elseif gameLocale == "esES" then
	elseif gameLocale == "zhTW" then
	
	end
end

function EE:RecountSetup()
	if not EE.initialized then return end
	
	UpdateLocale()
	
	if E.db.skins.embedright == "RECOUNT" then
		-- DEFAULT_CHAT_FRAME:AddMessage("[Recount #178] Embed enabled.")
		CreateEmbedRecount()
		LoadSkin()
	end
end