-- Import ElvUI Engine
local E, L, DF = unpack(ElvUI); --Engine
local EE = ElvUI_EmbedRight
local S = E:GetModule('Skins')

local function LoadSkin()
	if E.db.skins.skada.enable ~= true then return end
	-- Add proper check for addon
	if not Skada then return end

	local Skada = Skada
	local barmod = Skada.displays["bar"]
	
	if not barmod.ApplySettingsEE then
		barmod.ApplySettingsEE = barmod.ApplySettings
	end
	barmod.ApplySettings = function(self, win)
		barmod.ApplySettingsEE(self, win)
		
		if E.db.skins.embedright == "SKADA" then
			win.bargroup.button:SetFrameStrata("MEDIUM")
			win.bargroup.button:SetFrameLevel(5)	
			win.bargroup:SetFrameStrata("MEDIUM")
		end		
	end	

	local function EmbedWindow(window, width, barheight, height, point, relativeFrame, relativePoint, ofsx, ofsy)
		window.db.barwidth = width
		window.db.barheight = barheight
		if window.db.enabletitle then 
			height = height - barheight
		end
		window.db.background.height = height
		window.db.spark = false
		window.db.barslocked = true
		window.bargroup:ClearAllPoints()
		window.bargroup:SetPoint(point, relativeFrame, relativePoint, ofsx, ofsy)
		
		barmod.ApplySettings(barmod, window)
	end

	local barSpacing = 1
	local borderWidth = 1
	function EmbedSkada()
		local windows = {}
		for _, window in ipairs(Skada:GetWindows()) do
			tinsert(windows, window)
		end			
		
		local panelWidth = SkadaPanel:GetWidth()
		local panelHeight = SkadaPanel:GetHeight()

		-- windows[1].db.enabletitle
		-- panelHeight = panelHeight - (RightChatTab:GetHeight() + 8)
		
		if #windows == 1 then
			EmbedWindow(
				windows[1], 											-- window
				(panelWidth - 4), 										-- width
				(panelHeight - (barSpacing * 6)) / 8,					-- barHeight
				(panelHeight + 1),										-- height
				"BOTTOMRIGHT", 											-- point
				SkadaPanel, 											-- relativeFrame
				"BOTTOMRIGHT", 											-- relativePoint
				-2, 													-- ofsx
				3														-- ofsy
			)
		elseif #windows == 2 then
			EmbedWindow(
				windows[1], 
				((panelWidth - 6) / 2) - (borderWidth + E.mult), 
				(panelHeight - (barSpacing * 6)) / 8, 
				panelHeight + 1,  
				"BOTTOMRIGHT", 
				SkadaPanel, 
				"BOTTOMRIGHT", 
				-2, 
				3
			)
			EmbedWindow(
				windows[2], 
				((panelWidth - 6) / 2) - (borderWidth + E.mult), 
				(panelHeight - (barSpacing * 6)) / 8, 
				panelHeight + 1,  
				"BOTTOMLEFT", 
				SkadaPanel, 
				"BOTTOMLEFT", 
				2, 
				3
			)
		elseif #windows > 2 then
			EmbedWindow(
				windows[1], 
				((panelWidth - 6) / 2) - (borderWidth + E.mult), 
				(panelHeight - (barSpacing * 6)) / 8, 
				panelHeight + 1,  
				"BOTTOMRIGHT", 
				SkadaPanel, 
				"BOTTOMRIGHT", 
				-2, 
				2
			)
			EmbedWindow(
				windows[2], 
				((panelWidth - 6) / 2) - (borderWidth + E.mult), 
				((panelHeight / 2) - (barSpacing * 6)) / 4, 
				panelHeight / 2 - 2,  
				"BOTTOMLEFT", 
				SkadaPanel, 
				"BOTTOMLEFT", 
				2, 
				2
			)
			EmbedWindow(
				windows[3], 
				windows[2].db.barwidth -1 , 
				((panelHeight / 2) - (barSpacing * 6)) / 4, 
				panelHeight / 2 - 2,  
				"BOTTOMLEFT", 
				windows[2].bargroup.backdrop, 
				"TOPLEFT", 
				2, 
				3
			)
		end
	end

	-- Update pre-existing displays
	for _, window in ipairs(Skada:GetWindows()) do
		window:UpdateDisplay()
	end	
	
	if E.db.skins.embedright == "SKADA" then
		if not Skada.CreateWindow_ then 
			Skada.CreateWindow_ = Skada.CreateWindow
		end
		function Skada:CreateWindow(name, db)
			Skada:CreateWindow_(name, db)
			EmbedSkada()
		end

		if not Skada.DeleteWindow_ then
			Skada.DeleteWindow_ = Skada.DeleteWindow
		end
		function Skada:DeleteWindow(name)
			Skada:DeleteWindow_(name)
			EmbedSkada()
		end

		local Skada_Skin = CreateFrame("Frame")
		Skada_Skin:RegisterEvent("PLAYER_ENTERING_WORLD")
		Skada_Skin:SetScript("OnEvent", function(self)
			self:UnregisterAllEvents()
			self = nil

			EmbedSkada()

			if E.db.skins.embedrighttoggle == true then
				for _, window in ipairs(Skada:GetWindows()) do
					if window:IsShown() then
						window.db.hidden = true
						window:Hide()
					end
				end
			end
		end)
			
		if RightChatTab then
			local button = CreateFrame('Button', 'SkadaToggleSwitch', RightChatTab)
			button:Width(42)
			-- button:Height(RightChatPanel:GetHeight() - 4)
			button:Height(22)
			button:Point("RIGHT", RightChatTab, "RIGHT", -2, 0)
			
			button.tex = button:CreateTexture(nil, 'OVERLAY')
			button.tex:SetTexture([[Interface\AddOns\ElvUI\media\textures\vehicleexit.tga]])
			button.tex:Point('TOPRIGHT', -2, -2)
			button.tex:Height(button:GetHeight() - 4)
			button.tex:Width(16)
			
			button.text = button:CreateFontString(nil, "THINOUTLINE")
			button.text:FontTemplate()
			button.text:SetPoint('RIGHT', button.tex, 'LEFT')
			button.text:SetTextColor(unpack(E["media"].rgbvaluecolor))
			
			-- button:SetScript('OnEnter', function(self) button.text:SetText(L["Toggle"]..' Skada') end)
			button:SetScript('OnEnter', function(self) button.text:SetText(L["TOGGLE"]..' '..L["SKADA"]) end)			
			button:SetScript('OnLeave', function(self) self.tex:Point('TOPRIGHT', -2, -2); button.text:SetText(nil) end)
			button:SetScript('OnMouseDown', function(self) self.tex:Point('TOPRIGHT', -4, -4) end)
			button:SetScript('OnMouseUp', function(self) self.tex:Point('TOPRIGHT', -2, -2) end)
			button:SetScript('OnClick', function(self) Skada:ToggleWindow() end)
		end	

		if E.db.skins.embedrighttoggle == true then
			RightChatPanel:HookScript("OnShow", function()
				for _, window in ipairs(Skada:GetWindows()) do
					window:Hide()
					--[[
					if window:IsShown() then
						window.db.hidden = true
						window:Hide()
					end
					--]]
				end
			end)
			RightChatPanel:HookScript("OnHide", function()
				for _, window in ipairs(Skada:GetWindows()) do
					window:Show()
					--[[
					if not window:IsShown() then
						window.db.hidden = false
						window:Show()
					end
					--]]
				end
			end)
		end
		
	end
	
end

local function CreateEmbedSkada()
	local skadapanel = CreateFrame('Frame', 'SkadaPanel', E.UIParent)
	skadapanel:Width(E.db.core.panelWidth)
	local tabHeight = 0
	if RightChatTab then tabHeight = RightChatTab:GetHeight() + 8; end
	local panelHeight = E.db.core.panelHeight - tabHeight
	skadapanel:Height(panelHeight)
	if RightChatTab then skadapanel:Point("TOPLEFT", RightChatTab,"BOTTOMLEFT", 0, -10);
	else skadapanel:Point("TOPLEFT", RightChatPanel,"TOPLEFT", 0, -5); end
	skadapanel:Point("BOTTOMRIGHT", RightChatPanel,"BOTTOMRIGHT", -5, 31)
	skadapanel:SetFrameLevel(5)
end

local function UpdateLocale()
	local gameLocale = GetLocale()
	
	-- enGB and enUS are the same
	if gameLocale == "enGB" then
		gameLocale = "enUS"
	end
	
	-- esMX and esES are the same
	if gameLocale == "esMX" then
		gameLocale = "esES"
	end
	
	if gameLocale == "enUS" then
	
	elseif gameLocale == "zhCN" then
	elseif gameLocale == "frFR" then
	elseif gameLocale == "deDE" then
	elseif gameLocale == "krUS" then
	elseif gameLocale == "ruRU" then
	elseif gameLocale == "esES" then
	elseif gameLocale == "zhTW" then
	
	end
end

function EE:SkadaSetup()
	if not EE.initialized then return end
	
	UpdateLocale()

	if E.db.skins.embedright == "SKADA" then
		DEFAULT_CHAT_FRAME:AddMessage("["..L["SKADA"].."] Embed enabled.")
		CreateEmbedSkada()
		LoadSkin()
	end
end